/*
 * File: FunWithText.java
 * ================================================================
 * A program where we have fun with text!
 */
import acm.program.*;

public class FunWithText extends ConsoleProgram {
	/**
	 * Given a string, returns the reverse of that string.
	 * <p>
	 * A note: You can also get the reverse of a string by calling
	 * string.reverse(). We didn't talk about this method in lecture,
	 * but it does indeed exist!
	 * 
	 * @param text The text to reverse.
	 * @return The reverse of that text.
	 */
	private String reverse(String text) {
		String result = "";
		
		/* Walk backwards over the characters in the string, appending
		 * each to the result.
		 */
		for (int i = text.length() - 1; i >= 0; i--) {
			char current = text.charAt(i);
			result += current;
		}
		
		return result;
	}
	
	/**
	 * Given a string, hands back a new string consisting of all the
	 * letters from the original string in the order in which they
	 * appear. Equivalently, this hands back a copy of the original
	 * string in which all non-letters have been removed.
	 * 
	 * @param text The text to process.
	 * @return That string with all letters removed.
	 */
	private String lettersIn(String text) {
		String result = "";
		for (int i = 0; i < text.length(); i++) {
			char curr = text.charAt(i);
			if (Character.isLetter(curr)) {
				result += curr;
			}
		}
		return result;
	}
	
	/**
	 * Given a string, returns whether that string is a palindrome (that is,
	 * whether it's the same forwards and backwards.)
	 * <p>
	 * This code still needs some work - we'll talk about that more next time!
	 * 
	 * @param text The text to test.
	 * @return Whether it's a palindrome.
	 */
	private boolean isPalindrome(String text) {
		text = text.toLowerCase();
		text = lettersIn(text);
		return text.equals(reverse(text));
	}
	
	
	public void run() {
		setFont("UbuntuMono-26-BOLD");
		
		String line = readLine("Enter some text: ");		
		println("Is that a palindrome? " + isPalindrome(line));
	}
}